#include <iostream>


using namespace std;

class Time
{
public:
    Time(int hours, int minutes, int seconds){
        this->hours = hours%24 + minutes/60 + seconds/3600;
        this->minutes = minutes%60 + (seconds%3600)/60;
        this->seconds = seconds%60;
    }

    Time(int t){
        this->hours = (t/3600)%24;
        this->minutes = (t/60)%60;
        this->seconds = t%60;
    }

    Time(){

    }

    ~Time(){

    }
    Time(const Time& other){
        this->hours = other.hours;
        this->minutes = other.minutes;
        this->seconds = other.seconds;
    }

    void setSeconds(int s){
        this->seconds = s;
    }
    void setMinutes(int m){
        this->minutes = m;
    }
    void setHours(int h){
        this->hours = h;
    }
    int getSeconds(){
        return this->seconds;
    }
    int getMinutes(){
        return this->seconds;
    }
    int getHours(){
        return this->seconds;
    }
    void print(){
        cout << "The time is: " << this->hours << ":" << this->minutes << ":" << this->seconds << "." << endl;
    }
    Time operator+(const Time &t){
        return Time(this->hours+t.hours, this->minutes+t.minutes, this->seconds + t.seconds);
    }
    bool operator>(const Time &t){
        return this->getTimeInSeconds() > t.getTimeInSeconds();
    }
    bool operator>=(const Time &t){
        return this->getTimeInSeconds() >= t.getTimeInSeconds();
    }
    bool operator<(const Time &t){
        return this->getTimeInSeconds() < t.getTimeInSeconds();
    }
    bool operator<=(const Time &t){
        return this->getTimeInSeconds() <= t.getTimeInSeconds();
    }
    bool operator==(const Time &t){
        return this->getTimeInSeconds() == t.getTimeInSeconds();
    }
    int getTimeInSeconds() const{
        return this->hours*3600 + this->minutes*60 + this->seconds;
    }

private:
    int hours, minutes, seconds;
};


int timeinseconds(int hours, int minutes, int seconds);
void BubbleSort(Time a[], int size);

int main()
{
    int t, seconds, minutes, hours;
    cout << "Enter a number in seconds: " << endl;
    cin >> t;
    hours = (t/3600)%24;
    minutes = (t/60)%60;
    seconds = t%60;

    cout << "The time is: " << hours << ":" << minutes << ":" << seconds << "." << endl;
    cout << "You entered: " << timeinseconds(hours, minutes, seconds) << endl;

    const int size = 10;
    Time times[size] = {Time(12), Time(3600), Time(2, 5, 10), Time(291),
                        Time(26,13,24), Time(2,2,41), Time(0,170,2),
                        Time(0,61,3660), Time(1038), Time(1200)};

    int timeNeeded = 0;
    for(int i = 0; i < size; i++){
        timeNeeded += times[i].getTimeInSeconds();
    }
    cout << "You need " << timeNeeded << " seconds to complete the 10 tasks." << endl;

    cout << "Sorting the array ... " << endl << endl;
    BubbleSort(times, size);
    for(int i = 0; i < size; i ++){
        cout << times[i].getTimeInSeconds() << endl;
    }
    cout << endl << "Most important tasks: " << endl << "1st: " << endl;
    times[0].print();
    cout << "2nd: " << endl;
    times[1].print();

    return 0;
}


int timeinseconds(int hours, int minutes, int seconds){
    return hours*3600 + minutes*60 + seconds;
}

void BubbleSort(Time a[], int size){
    Time tTemp;
    for(int i = 0; i < size; i++){
        for(int j = 0; j < size-i-1; j++){
            if(a[j]<a[j+1]){
                tTemp = a[j];
                a[j] = a[j+1];
                a[j+1] = tTemp;
            }
        }
    }
}
