#include <iostream>

using namespace std;

class smartA{
private:
	int size;

public:
	int *p;
	smartA(int sz=10){
		size = sz;
		p = new int[sz];
	}

	smartA(int arr[], int sz=10){
		size = sz;
		p = new int[sz];
		for(int i = 0; i < sz; i ++){
			p[i] = arr[i];
		}
	}
	smartA(const smartA &sm){
		p = new int[sm.size];
		sm.getSmartA(p, size);
	}

	~smartA(){
		delete [] p;
	}

	void getSmartA(int a[], int &sizea) const{
		sizea = size;
		for(int i = 0; i < sizea; i ++){
					a[i] = p[i];
			}
	}

	void setSmartA(const int a[], int sizea){
		delete [] p;
		size = sizea;
		p = new int[size];
		for(int i = 0; i < size; i ++){
					p[i] = a[i];
				}
	}


	void copyInto(smartA &s){
		s.setSmartA(p, size);
	}

	smartA operator+(const smartA &b){
		smartA c(b.size+size);
		for(int i = 0; i < size; i++){
			c.p[i] = p[i];
		}
		for(int i = 0; i < b.size; i++){
			c.p[size+i]= b.p[i];
		}
		c.setSmartA(c.p, size+b.size);
		return c;
	}

	void append(int i){
		cout << "Appending element " << i << "... " << endl;
		size++;
		int arr[size];
		for(int k = 0; k < size-1; k++){
			arr[k] = p[k];
		}
		arr[size-1] = i;
		setSmartA(arr, size);
	}

	int removel(){
		cout << "Removing last element... " << endl;
		if(size == 0)
			return p[--size];
		else{
			cout << "The array is empty" << endl;
			return -1;
		}
	}

	int removef(int k){
		if(size == 0){
			cout << "The array is empty" << endl;
			return -1;
		}
		int last = p[size-1];
		cout << "Removing " << k << "th element... " << endl;
		for(int i = k; i < size-1; i++){
			p[i] = p[i+1];
		}
		size--;
		return last;
	}

};

void print(const smartA &s);
void readSmartArray(smartA &s);


int main(){
	const int myArrSize = 7;
	int myArr[myArrSize] = {-1, 23, 39, 0, -20, 329, -1};
	smartA s = smartA(myArr,myArrSize);
	print(s);
	s.removel();
	print(s);
	s.removef(4);
	print(s);
	s.append(28);
	print(s);

	smartA s2;
	cout << "Now copying contents of Smart Array 1 into Smart Array 2" << endl;
	s.copyInto(s2);
	cout << "Modifying Smart Array 2... " << endl;
	s2.removef(1);
	s2.removef(3);
	s2.append(-29);
	cout << "_____________________________" << endl << "Smart Array 1: " << endl;
	print(s);
	cout << " ~~~~~~~~~~~~~ " << endl << "Smart Array 2: " << endl;
	print(s2);
	cout << " ~~~~~~~~~~~~~ " << endl;
	smartA s3 = s + s2;
	cout << "Smart Array 3 = Smart Array 1 + Smart Array 2: "<< endl;
	print(s3);
	cout << "_____________________________" << endl;

	cout << "Reading s3 into an array..." << endl << endl;
	
	smartA s4;
	readSmartArray(s4);
	print(s4);
	cout << endl;
    return 0;
}


void readSmartArray(smartA& s){
	cout << "Enter the size of your smart array: " << endl;
	int size;
	cin >> size;
	int a[size];
	cout << "Enter " << size << " integers:" << endl;
	for(int i = 0; i < size; i ++){
	cin >> a[i];
	}
	s.setSmartA(a, size);

}

void print(const smartA &s){
	int arr[1000];
	int aSize;
	s.getSmartA(arr, aSize);
	int i = 0;
	while(i < aSize){
		int j = 0;
		while(j < 5 && i < aSize){
		cout << arr[i] << " ";
			j++;
			i++;
		}
		cout << endl;
	}
	cout << endl;

}
