#include <iostream>

using namespace std;

class Fine
{
public:
    int x, y;

    Fine(){
        x = 0; y = 0;
    }

    Fine(int x, int y){
        this->x = x;
        this->y = y;
    }

    Fine(const Fine& f){
            this->x = f.getX();
	    this->y = f.getY();
    }

    void setFine(int a, int b){
        x = a; y = b;
    }

    int getX() const{
        return x; // Seriously tho, why are we using getters if the member variables are public??!
    }

    int getY() const{
        return y;
    }

    Fine operator+(const Fine &f2) const{
        return Fine(this->x+f2.getY(), this->y+f2.getX());
    }

    Fine operator-(const Fine &f2) const{
        return Fine(this->x-f2.getY(), this->y-f2.getX());
    }

    Fine operator*(const Fine &f2) const{
        return Fine(this->x*f2.getY(), this->y*f2.getX());
    }

    Fine operator/(const Fine &f2) const{
        return Fine(this->x/f2.getY(), this->y/f2.getX());
    }
    Fine operator++(){
        Fine p;
        p.x = ++x;
        p.y = ++y;
        return p;
    }
    Fine operator++(int){
   	Fine p;
        p.x = x++;
        p.y = y++;
        return p; 
    }
    int trace(){
        return x*y;
    }

    void print(){
        cout << "(" << this->x << "," << this->y <<")";
    }

    void read(){
        char c;
        cin >> c >> x >> c >> y >> c;
    }

};

Fine sum(const Fine &u, const Fine &v){
    Fine f1 = u;
    Fine f2 = v;
    Fine sum = u/v;
    for(int i = 1; i < 9; i++){
        f1 = f1*u;
	f2 = f2*v;
        sum = sum+(f1/f2);
    }
    return sum;
}

int main(){
    cout << "Enter a fine number (x,y):" << endl;
    Fine a;
    a.read();
    cout << "You entered: " << endl;
    a.print();
    cout << endl;
    Fine u = Fine(4, 3);
    Fine v = Fine(2, 1);
    cout << "Now, given u = (4,3) and v = (2,1): " << endl << endl;
    cout << "Sum = u/v + u^2/v^2 + u^3/v^3 + ... + u^9/v^9: " << endl << endl;
    cout << "Answer: ";
    sum(u, v).print();
    cout << endl << "Post increment: ";
    (u++).print();
    cout << endl << "Pre increment: ";
    (++v).print();
    cout << endl << "Trace(v): ";
    cout << v.trace() << endl;
    

    return 0;
}
