#include <iostream>

using namespace std;

class Book
{
public:
    Book(){
        nout = 0;
        students = new int[nout];
    }
    Book(int is, int nc){
        isbn = is;
        ncopies = nc;
        nout = 0;
        students= new int[nout];
    }
    int getIsbn() const{
        return isbn;
    }
    int getNCopies() const{
        return ncopies;
    }
    int getNout() const{
        return nout;
    }
    void getStudents(int a[]) const{
        for(int i = 0; i < nout; i++){
            a[i] = students[i];
        }
    }
    void setIsbn(int i){
        isbn = i;
    }
    void setNCopies(int n){
        ncopies = n;
    }
    void reset(){
        delete [] students;
        nout = 0;
        students = new int[nout];
    }

    void borrow(int id){
        cout << "Student " << id << " is attempting to borrow the book with ISBN: " << isbn << "." << endl;
        if(ncopies > 0){
            ncopies--;
            nout++;
            int arrTemp[nout];
            for(int i = 0; i < nout-1; i++){
                arrTemp[i] = students[i];
            }
            delete [] students;
            students = new int[nout];
            for(int i = 0; i < nout-1; i++){
                students[i] = arrTemp[i];
            }
            students[nout-1] = id;
        }
        else
            cout << "This book isn't available." << endl;

    }
    void breturn(int id){
        cout << "Student " << id << " is attempting to return the book with ISBN: " << isbn << "." << endl;
        if(nout >0){
            int index = -1;
            for(int i = 0; i < nout; i++){
                if(id == students[i]){
                    index = i;
                    break;
                }
            }
            if(index >-1){
            for(int i = index; i < nout-1; i++){
                students[i] = students[i+1]; // Remove the index-th element from the list.
            }
            ncopies++;
            nout--;
            int arrTemp[nout];
            for(int i = 0; i < nout; i++){
                arrTemp[i] = students[i];
            }
            delete [] students;
            students = new int[nout];
            for(int i = 0; i < nout; i++){
                students[i] = arrTemp[i];
            }
            }
            else{
                cout << "This student hasn't borrowed this book!" << endl;
            }
        }
        else{
            cout << "No one has borrowed this book!" << endl;
        }

    }
    ~Book(){
        delete [] students;
    }

    Book(const Book& bk){
        isbn = bk.getIsbn();
        ncopies = bk.getNCopies();
        nout = bk.nout;
        students = new int[nout];
	bk.getStudents(students);
    }

    void printInfo(){ // To refrain calling these several times in main.
        cout << endl;
        cout << "Info on book: " << isbn << endl;
        cout << "Copies remaining: " << ncopies << endl;
        cout << "Copies currently borrowed: " << nout<< endl;
        cout << "Students borrowing: " << endl;
        for(int i = 0; i < nout ; i++){
            cout << students[i] << endl;
        }
        if(!nout)
            cout << "N/A" << endl;
        cout << endl;
    }

private:
    int isbn;
    int ncopies;
    int nout;
    int *students;
};

void sort(Book *arr[], int size);

int main(){
    const int size = 5, s1 = 201801562, s2= 201801555;
    Book math = Book(11, 3);
    Book physics = Book(21, 7);
    Book history = Book(31, 1);
    Book chemistry = Book(44, 4);
    Book biology = Book(24, 0);

    Book books[size] = {physics, math, biology, chemistry, history}; // Not necessarily sorted.

    books[4].printInfo();
    books[4].borrow(s2);
    books[4].printInfo();
    books[4].borrow(s1);
    books[4].printInfo();

    Book* bookPtrs[size];

    for(int i = 0; i < size; i++){
        bookPtrs[i] = &books[i]; // Fill the pointers array.
    }

    sort(bookPtrs, size);
    cout << "The array is now sorted." << endl;

    bookPtrs[0]->printInfo();
    bookPtrs[0]->borrow(s1);
    bookPtrs[0]->borrow(s2);
    bookPtrs[0]->printInfo();
    bookPtrs[0]->breturn(s1);
    bookPtrs[0]->printInfo();


    return 0;
}

void sort(Book* arr[], int size){
    Book *bTemp;
    for(int i = 0; i < size; i++){
        for(int j = i; j < size; j++){
            if(arr[j]->getIsbn()<arr[i]->getIsbn()){
                bTemp = arr[i];
                arr[i] = arr[j];
                arr[j] = bTemp;
            }
        }
    }
}
