#include <iostream>

using namespace std;

class Student
{
private:
    int id, section, quiz1, quiz2, finalExam;
    static int nObjects;
public:
    // Constructors
    Student(){
        id = -1;
        section = -1;
	quiz1 = 0; 
	quiz2 = 0;
	finalExam = 0;
        nObjects++;
    }
    Student(int ID, int sec){
        id = ID;
        section = sec;
        nObjects++;
    }

    Student(const Student& st){
        Student copy = st;
    }

    //Destructor
    ~Student(){
        nObjects--;
    }

    // Getters
    int getId(){
        return id;
    }
    int getSection(){
        return section;
    }
    int getQuiz1(){
        return quiz1;
    }
    int getQuiz2(){
        return quiz2;
    }
    int getFinalExam(){
        return finalExam;
    }
    static int getNObjects(){
        return nObjects;
    }
    // Setters
    void setId(int i){
        id = i;
    }
    void setSection(int sec){
        section = sec;
    }
    void setQuiz1(int q1){
        if( q1>= 0 && q1<=100) quiz1 = q1;
    }
    void setQuiz2(int q2){
        if( q2>= 0 && q2<=100) quiz2 = q2;
    }
    void setFinalExam(int f){
        if( f>= 0 && f<=100) finalExam = f;
    }

    double quizAverage(){
        return static_cast<double>(quiz1+quiz2)/2;
    }

    double finalGrade(){
        return (quizAverage()+finalExam)/2;
    }

    void displayGrade(){
        cout << "ID: " << id << "\t" << finalGrade() << endl;
    }


};

void BubbleSort(Student arr[], int size);
double classAverage(Student arr[], int size);

int Student::nObjects = 0;

int main()
{
    Student ast[4] = {Student(38927, 6), Student(20126, 3), Student(21555, 8), Student(10033, 8)};
    for(int i = 0; i < 4; i++){
        // Initialize Grades for every student
        ast[i].setQuiz1(100-6*i);
        ast[i].setQuiz2(50+2*i*i);
        ast[i].setFinalExam(90-5*i*i);

        // Display their final average
        ast[i].displayGrade();
    }

    // Sort the Grades
    BubbleSort(ast, 4);

    // Display grades after sorting
    cout << endl << "Sorting in ascending order ..." << endl;
    for(int i = 0; i < 4; i++){
        ast[i].displayGrade();
    }

    // Display the class average
    cout << endl << "The class average is: " << classAverage(ast, 4) << endl;

    cout << endl << "The number of Student objects is: "  << Student::getNObjects() << endl;

    return 0;
}

void BubbleSort(Student arr[], int size){
    Student StdTemp;
    for(int i = 0; i < size; i++){
        for(int j = 0; j < size - i; j++){
            if(arr[j].finalGrade() > arr[j+1].finalGrade()){
                StdTemp = arr[j];
                arr[j] = arr[j+1];
                arr[j+1] = StdTemp;
            }
        }
    }
}

double classAverage(Student arr[], int size){
    double sum = 0;
    for(int i = 0; i < size; i++){
        sum += arr[i].finalGrade();
    }
    return sum/size;
}
